var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  MessageQueue: () => MessageQueue
});
module.exports = __toCommonJS(src_exports);
var MessageQueue = class {
  constructor(options) {
    this._queue = [];
    this._flushing = false;
    this._ready = false;
    this._send = options.send;
    this._isReady = options.isReady;
    this._flushTimeout = options.flushTimeout || 16;
  }
  get ready() {
    return this._ready || (this._ready = this._isReady());
  }
  flush() {
    if (!this.ready) {
      return;
    }
    this._flush();
  }
  _flush() {
    if (this._flushing) {
      return;
    }
    this._flushing = true;
    while (this._queue.length > 0) {
      const e = this._queue.shift();
      this._send(e);
    }
    this._flushing = false;
  }
  push(data) {
    this._queue.push(data);
    this.flush();
  }
  clear() {
    this._queue = [];
    this._flushing = false;
  }
  dispose() {
    this.clear();
  }
  get length() {
    return this._queue.length;
  }
  scheduleFlush() {
    if (this.length === 0) {
      return;
    }
    if (this.ready) {
      this._flush();
      return;
    }
    if (this.scheduled) {
      clearTimeout(this.scheduled);
    }
    this.scheduled = setTimeout(() => {
      this.scheduleFlush();
    }, this._flushTimeout);
  }
};
